summaryrefslogtreecommitdiffstats
path: root/builder/modules.d/dnbd3-rootfs/module-setup.sh
diff options
context:
space:
mode:
authorJonathan Bauer2017-03-07 11:14:32 +0100
committerJonathan Bauer2017-03-07 11:14:32 +0100
commit9b61577c3ceb809c2473d4757590a01054466eaf (patch)
tree2bbbd2dc0a7e79f8509b53bef2f1aba939900489 /builder/modules.d/dnbd3-rootfs/module-setup.sh
parentYannick Bilger's WLAN boot prototype (diff)
downloadsystemd-init-9b61577c3ceb809c2473d4757590a01054466eaf.tar.gz
systemd-init-9b61577c3ceb809c2473d4757590a01054466eaf.tar.xz
systemd-init-9b61577c3ceb809c2473d4757590a01054466eaf.zip
moved all dracut modules to modules.d/ + support
Diffstat (limited to 'builder/modules.d/dnbd3-rootfs/module-setup.sh')
-rwxr-xr-xbuilder/modules.d/dnbd3-rootfs/module-setup.sh269
1 files changed, 269 insertions, 0 deletions
diff --git a/builder/modules.d/dnbd3-rootfs/module-setup.sh b/builder/modules.d/dnbd3-rootfs/module-setup.sh
new file mode 100755
index 00000000..549900ad
--- /dev/null
+++ b/builder/modules.d/dnbd3-rootfs/module-setup.sh
@@ -0,0 +1,269 @@
+#!/usr/bin/env bash
+# -*- coding: utf-8 -*-
+# region imports
+source "$(dirname "${BASH_SOURCE[0]}")/scripts/rebash/core.sh"
+core.import exceptions
+core.import logging
+core.import utils
+core.import "$(core_abs_path "$(dirname "${BASH_SOURCE[0]}")/scripts/build.sh")"
+# endregion
+# region forward "build-initrfams.sh" logging configuration if present.
+_parse_dracut_args() {
+ local __doc__='
+ Set log level via dracut logging options and returns current debug state.
+
+ >>> echo "$_debug"
+ 1
+ >>> _parse_dracut_args; echo $?
+ 1
+
+ >>> _parse_dracut_args --stdlog 3; echo $?
+
+ >>> _parse_dracut_args --stdlog 4; echo $?
+ >>> logging.get_commands_level
+ >>> logging.get_level
+ 0
+ debug
+ debug
+
+ >>> logging.get_level
+ critical
+ >>> _parse_dracut_args --stdlog 4 --verbose
+ >>> logging.get_level
+ debug
+
+ >>> _parse_dracut_args --stdlog 4 --unknown-dracut-option; echo $?
+ 0
+ '
+ local verbose=false
+ local debug=false
+ while true; do
+ case "$1" in
+ --stdlog)
+ shift
+ local level="$1"
+ shift
+ [[ "$level" -ge 4 ]] && debug=true
+ ;;
+ --verbose)
+ shift
+ verbose=true
+ ;;
+ '')
+ break
+ ;;
+ *)
+ shift
+ ;;
+ esac
+ local level
+ $verbose && level=info
+ $debug && level=debug
+ logging.set_level "$level"
+ logging.set_commands_level debug
+ done
+ $debug
+ return $?
+}
+_debug=0
+_parse_dracut_args ${dracut_args[*]} || _debug=$?
+# endregion
+clean() {
+ local __doc__='
+ Removes all compiled kernel specific files.
+ NOTE: This method is triggered manually and not supported by dracut itself.
+
+ Example:
+
+ `clean`
+ '
+ build_clean_xmount "$moddir/binaries/xmount/"
+ build_clean_qemu_xmount "$moddir/binaries/qemu-xmount/"
+ build_clean_dnbd3 "$moddir/binaries/dnbd3/"
+ build_clean_systemd_preserve_process_marker \
+ "$moddir/binaries/systemd-preserve-process-marker/"
+ return 0
+}
+# region dracut plugin api
+check() {
+ local __doc__='
+ Checks wether all template system assumptions are satisfied.
+
+ Example:
+
+ `check`
+ '
+ exceptions.activate
+ # NOTE: xmount must be compiled before qemu_xmount
+ local xmount_is_built=true
+ if [[ ! -f "$moddir/binaries/xmount/trunk/build/src/xmount" ]]; then
+ if ! build_compile_xmount "$moddir/binaries/xmount/"; then
+ xmount_is_built=false
+ fi
+ fi
+ if $xmount_is_built && [[ \
+ ! -f "$moddir/binaries/qemu-xmount/libxmount_input_qemu.so" \
+ ]]; then
+ build_compile_qemu_xmount "$moddir/binaries/qemu-xmount/" || \
+ xmount_is_built=false
+ fi
+ $xmount_is_built || logging.warn \
+ "Compiling \"xmount\" failed -> No support for container files (only raw images)."
+
+ if [[ ! -f "$moddir/binaries/dnbd3/build/dnbd3.ko" ]] || \
+ [[ ! -f "$moddir/binaries/dnbd3/build/dnbd3-client" ]]
+ then
+ build_compile_dnbd3 "$moddir/binaries/dnbd3/"
+ [[ $? != 0 ]] && return 1
+ fi
+ if [[ ! -f "$moddir/binaries/systemd-preserve-process-marker/systemd-preserve-process-marker" ]]; then
+ build_compile_systemd_preserve_process_marker \
+ "$moddir/binaries/systemd-preserve-process-marker/"
+ [[ $? != 0 ]] && return 1
+ fi
+ # NOTE: This are workarounds for:
+ # - distributions where "systemd-udevd" doesn't lives in "/usr/lib" but in
+ # "/lib".
+ local alternate_systemd_udevd_location='/lib/systemd/systemd-udevd'
+ if [[ ! -f "${systemdutildir}/systemd-udevd" ]] && \
+ [[ -f "$alternate_systemd_udevd_location" ]]; then
+ mkdir --parents "${initdir}${systemdutildir}"
+ ln --symbolic --force "$alternate_systemd_udevd_location" \
+ "${initdir}${systemdutildir}/systemd-udevd"
+ #cp "$alternate_systemd_udevd_location" \
+ # "${initdir}${systemdutildir}/systemd-udevd" 1>&2
+ fi
+ # - "/usr/bin/sh" isn't available but "/bin/sh".
+ if [[ ! -f /usr/bin/sh ]] && [[ -f /bin/sh ]]; then
+ ln --symbolic --force /bin/sh /usr/bin/sh
+ fi
+ exceptions.deactivate
+ # Tell dracut that this module should only be included if it is required
+ # explicitly.
+ return 255
+}
+depends() {
+ local __doc__='
+ Outputs all dependent dracut modules to make this module work.
+
+ >>> depends
+ +doc_test_contains
+ base
+ '
+ echo base network bash kernel-modules shutdown
+}
+installkernel() {
+ local __doc__='
+ Copies all needed kernel modules into initramfs file needed work at
+ runtime.
+
+ Example:
+
+ `installkernel`
+ '
+ inst "$moddir/binaries/dnbd3/build/dnbd3.ko" \
+ /usr/lib/modules/current/extra/dnbd3.ko
+ instmods dm_snapshot btrfs crc32c
+}
+install() {
+ local __doc__='
+ Copies all needed files into the initramfs image and registers all needed
+ dracut hooks.
+
+ Example:
+
+ `install`
+ '
+ # region binaries
+ inst "$moddir/binaries/dnbd3/build/dnbd3-client" /usr/bin/dnbd3-client
+ inst "$moddir/binaries/systemd-preserve-process-marker/systemd-preserve-process-marker" \
+ /usr/bin/systemd-preserve-process-marker
+ inst "$moddir/scripts/device-add-write-layer.sh" \
+ /usr/bin/device-add-write-layer
+ inst "$moddir/scripts/container-unpack-xmount.sh" \
+ /usr/bin/container-unpack-xmount
+ # xmount
+ local \
+ xmount_installation="$moddir/binaries/xmount/trunk/build/release_build"
+ inst "${xmount_installation}/usr/bin/xmount" /usr/bin/xmount
+ for file in ${xmount_installation}/usr/lib/xmount/*; do
+ inst "$file" /usr/lib/xmount/"$(basename "$file")"
+ done
+ inst "$moddir/binaries/qemu-xmount/libxmount_input_qemu.so" \
+ /usr/lib/xmount/libxmount_input_qemu.so
+ # endregion
+ # region hooks
+ inst_hook cmdline 00 "$moddir/hooks/enable-sysrq.sh"
+ # NOTE: Can be used to support old style ip append syntax and have an
+ # exclusive interface name.
+ inst_hook cmdline 10 \
+ "$moddir/hooks/prepare-kernel-command-line-parameter.sh"
+ inst_hook cmdline 90 "$moddir/hooks/set-dracut-environment-variables.sh"
+ inst_hook pre-udev 00 "$moddir/hooks/load-custom-kernel-modules.sh"
+ # Get the openslx config from the servers configured in the kernel command
+ # line (${SLX_SERVER}/${SLX_SERVER_BASE}/config).
+ inst_hook pre-mount 00 "$moddir/hooks/fetch-config.sh"
+ # make the final blockdevice for the root system (dnbd3 -> xmount ->
+ # device-mapper)
+ if dracut_module_included "systemd-initrd"; then
+ inst "$moddir/hooks/prepare-root-partition.sh" \
+ /usr/bin/dnbd3root
+ inst_simple "${moddir}/services/dnbd3root.service" \
+ "${systemdsystemunitdir}/dnbd3root.service"
+ mkdir --parents \
+ "${initdir}/${systemdsystemunitdir}/dracut-mount.service.requires"
+ ln_r "${systemdsystemunitdir}/dnbd3root.service" \
+ "${systemdsystemunitdir}/dracut-mount.service.requires/dnbd3root.service"
+ mkdir --parents \
+ "${initdir}/${systemdsystemunitdir}/initrd.target.requires"
+ ln_r "${systemdsystemunitdir}/dnbd3root.service" \
+ "${systemdsystemunitdir}/initrd.target.requires/dnbd3root.service"
+ # Copy systemd services to new root (so they don't get killed after
+ # switch_root)
+ inst_hook pre-pivot 00 \
+ "$moddir/hooks/copy-dnbd3-service-into-newroot.sh"
+ inst_hook pre-pivot 00 \
+ "$moddir/hooks/copy-dracut-systemd-files-into-newroot.sh"
+ inst_hook pre-shutdown 00 "$moddir/hooks/shutdown-umount.sh"
+ else
+ inst_hook pre-mount 10 "$moddir/hooks/prepare-root-partition.sh"
+ fi
+ inst_hook mount 10 "$moddir/hooks/mount-root-device.sh"
+ inst_hook pre-pivot 00 \
+ "$moddir/hooks/copy-openslx-configuration-into-newroot.sh"
+ # endregion
+ # region scripts
+ local file_path
+ for file_path in "$moddir/scripts/rebash/"*; do
+ inst "$file_path" "/usr/lib/rebash/$(basename "$file_path")"
+ done
+ inst "$moddir/scripts/tools.sh" "/usr/lib/openslx/tools.sh"
+ # endregion
+ # region configuration files
+ # Use terminal readline settings from the template system.
+ inst /etc/inputrc /etc/inputrc
+ # Set some aliases for the initramfs context.
+ if [[ "$_debug" == 0 ]]; then
+ inst "$moddir/configuration/bash" '/etc/bash.bashrc'
+ inst "$moddir/configuration/bash" '/etc/profile.d/aliases'
+ fi
+ # endregion
+ inst_multiple \
+ awk \
+ basename bash blockdev \
+ cat cut \
+ dd diff dirname dmsetup \
+ find fsck.ext4 \
+ grep \
+ insmod \
+ losetup lsblk \
+ mkfifo mkfs.ext4 mktemp mount mountpoint \
+ sed sleep sort \
+ tee touch tr \
+ wget
+}
+# endregion
+# region vim modline
+# vim: set tabstop=4 shiftwidth=4 expandtab:
+# vim: foldmethod=marker foldmarker=region,endregion:
+# endregion